#include <stdio.h>
#include <stdlib.h>
#include "configbits.h"
#include<xc.h>

/*
 * 
 */

int voltage;
        
void Nop_delay(void){
     Nop(); Nop(); Nop(); Nop();
     Nop(); Nop(); Nop(); Nop();
     Nop(); Nop(); Nop(); Nop();
     Nop(); Nop(); Nop(); Nop();
     Nop(); Nop(); Nop(); Nop();
     Nop(); Nop(); Nop(); Nop(); 
     Nop(); Nop(); Nop(); Nop();
     Nop(); Nop(); Nop(); Nop();
     Nop(); Nop(); Nop(); Nop();
     Nop(); Nop(); Nop(); Nop();
     Nop(); Nop(); Nop(); Nop();
     Nop(); Nop(); Nop(); Nop(); 
     Nop(); Nop(); Nop(); Nop();
     Nop(); Nop(); Nop(); Nop();
     Nop(); Nop(); Nop(); Nop();
     Nop(); Nop(); Nop(); Nop();
     Nop(); Nop(); Nop(); Nop();
     Nop(); Nop(); Nop(); Nop(); 
     Nop(); Nop(); Nop(); Nop();
     Nop(); Nop(); Nop(); Nop();
     Nop(); Nop(); Nop(); Nop();
     Nop(); Nop(); Nop(); Nop();
     Nop(); Nop(); Nop(); Nop();
     Nop(); Nop(); Nop(); Nop(); 
}

void delay(){
    unsigned int i, j;
    for (j=0; j<6; j++){
        for(i=0; i<2000;i++){}
    }
}

#define buff_full U2STAbits.UTXBF
void putu2(char c) 
{
    while(buff_full);//check that there is room in transmit fifo first
    U2TXREG = c;
    delay(); // delay to get around UART stop error (as per errata sheet)
}

#define data_ready U2STAbits.URXDA
char getu2()
{
    char c;
    while(!data_ready);  //check that there is a character to be read
    c = U2RXREG;
    return c;
}

void serial_init2(unsigned long rate) 
{  
    
  U2BRG = 102;  // set to 102 for rate of 57600
  U2MODE = 0; // turn off UART
  U2MODEbits.BRGH = 1; // enable high speed setting, because of formula^^
  U2MODEbits.UEN = 1; // enable UART
  U2STAbits.URXEN = 1; //enable receiver
  U2STAbits.UTXEN = 1; // enable transmitting
  U2MODEbits.ON = 1; // turn on UART
  
}

void _mon_putc(char c) // standard i/o print
{
    putu2(c);
}

void initClock(void) {
    SYSKEY = 0x00000000; // force lock
    SYSKEY = 0xAA996655; // unlock sequence
    SYSKEY = 0x556699AA; // lock sequence
    
    // user code to modify register contents for reference clock (RB15)
    REFO1CONbits.OE = 1; //  Reference oscillator module is enabled 
    REFO1CONbits.ON = 1; // turn it on
    REFO1CONbits.RODIV = 12; 
    REFO1TRIMbits.ROTRIM = 0;
    REFO1CONbits.ROSEL = 0b0000; // set ref clock to SYS CLK (part 6)
 
    // change the PLL multipliers so Fvco = 96 MHZ
    SPLLCONbits.PLLMULT = 0b0000101; // multiply sys clock by 12 (8*12 = 96 = FVCO)
    SPLLCONbits.PLLODIV = 0b010;
    
    // switch the clock source to PLL
    OSCCONbits.NOSC = 0b001; // set new oscillator source to PLL
    OSCCONbits.OSWEN = 1; // start the swtiching sequence
    while(OSCCONbits.OSWEN); // wait for switching to finish
    
    // relock
    SYSKEY = 0x00000000; // relock
}


void initUART2(void) {
    
    initClock();

    ANSELAbits.ANSA0 = 0; // make sure RA0 and RA1 are set to digital for UART2
    ANSELAbits.ANSA1 = 0;
    TRISAbits.TRISA0 = 1; // set TRISA bit 0 as input and 1 as output for UART2
    TRISAbits.TRISA1 = 0;
    
    SYSKEY = 0x00000000; // force lock
    SYSKEY = 0xAA996655; // unlock sequence
    SYSKEY = 0x556699AA; // lock sequence
    
    RPINR9bits.U2RXR = 0b0001; // set RP1 (RA0) to U2RX
    RPOR0bits.RP2R = 0b0100; // set RP2 (RA1) to U2TX pg 125
    //^Function 4 is U2TX (page 119)
    
    SYSKEY = 0x00000000; // relock

}

int main(int argc, char** argv) {
    initUART2();
    serial_init2(57600ul); //must define as ul (cast type)
    
    // Set pins 3 (RC0), 4 (RC1), 7 (RA2), 8(RA3), 9(RB4) to analog
    ANSELCbits.ANSC0 = 1; 
    ANSELCbits.ANSC1 = 1;
    ANSELAbits.ANSA2 = 1; 
    ANSELAbits.ANSA3 = 1;
    ANSELCbits.ANSC8 = 1;
    // Set pins 3 (RC0), 4 (RC1), 7 (RA2), 8(RA3), 9(RB4) to input
    TRISCbits.TRISC0 = 1;
    TRISCbits.TRISC1 = 1;
    TRISAbits.TRISA2 = 1;
    TRISAbits.TRISA3 = 1;
    TRISCbits.TRISC8 = 1;
    
    // Configure ADC
    AD1CON1bits.FORM = 0b000;  // integer 16-bit (DOUT = 0000 0000 0000 0000 0000 dddd dddd dddd)
    AD1CON1bits.SSRC = 0b0000; // Clearing the SAMP bit ends sampling and starts conversion
    AD1CON1bits.MODE12 = 1; // operate in 12-bit (not 10-bit mode)
    AD1CON1bits.ASAM = 1; // enable auto-sampling, Sampling begins immediately after last conversion completes; SAMP bit is automatically set
    //Control Register 2 AD1CON2
    AD1CON2bits.VCFG = 0b000; // sets AVDD and AVSS as voltage references
    AD1CON2bits.BUFREGEN = 1; // ADC result buffer is stored in buffer corresponding to Analog pin (RC0 = AN12 = ADC1BUF12))
    //Control Register 3 AD1CON3
    AD1CON3bits.ADRC = 0; // Clock derived from the Peripheral Bus Clock (PBCLK, 1:1 with SYSCLK)
    AD1CON3bits.ADCS = 8;  // ADC clock TAD = 8 peripheral clock TPB The user software must time the setting 
                           // and clearing of the SAMP bit for at least one TAD cycle to ensure that the ADC will detect the SAMP bit state transition.
    
      
    // Turn input scanning on (if we're scanning, the CH0SA bit is ignored)
    AD1CON2bits.CSCNA = 1; // input scanning enable
    AD1CON5bits.ASEN = 1; // enable auto scan (converts at the end of each ADRC cycle)
    AD1CON2bits.SMPI = 0b0111; // configure to convert every five inputs
    AD1CSSbits.CSS12 = 1; // set AN12 (C0) to be scanned
    AD1CSSbits.CSS13 = 1; // set AN13 (C1) to be scanned)
    AD1CSSbits.CSS5 = 1; // set AN5 (A2) to be scanned
    AD1CSSbits.CSS6 = 1; // set AN6 (A3) to be scanned)
    AD1CSSbits.CSS14 = 1; // set AN14 (C8) to be scanned
    
    // turn ADC on
    AD1CON1bits.ON = 1;
    
    // start the first sampling cycle
    AD1CON1bits.SAMP = 1;
    
    
   while(1) {
       AD1CON1bits.SAMP = 0; // set this bit to zero in our sample loop when we want sampling to stop and conversion to begin
       Nop_delay(); //give the ADC time to convert the value it reads in
       Nop_delay(); //give the ADC time to convert the value it reads in
       AD1CON1bits.SAMP = 1; // start sampling again
       
       // Load 1 data
       putu2(','); // send first character
       putu2(ADC1BUF12); // send voltage data (C0) out via UART2
       putu2(ADC1BUF13); // send C1 data
       printf("\r\n"); // new line
       
       AD1CON1bits.SAMP = 0; // set this bit to zero in our sample loop when we want sampling to stop and conversion to begin
       Nop_delay(); //give the ADC time to convert the value it reads in
       
       // Gen 1 data
       putu2('-'); // send first character
       putu2(ADC1BUF5); // send voltage data (A2) out via UART2
       putu2(ADC1BUF6); // send A3 data
       printf("\r\n"); // new line       
       
       AD1CON1bits.SAMP = 0; // set this bit to zero in our sample loop when we want sampling to stop and conversion to begin
       Nop_delay(); //give the ADC time to convert the value it reads in
    
    // Blocking diode
       putu2('0'); // send first character
       putu2(ADC1BUF14); // send voltage data (C8) out via UART2
       printf("\r\n"); // new line
    }
        
    return (EXIT_SUCCESS);
}
